#include <stdio.h>

#define	MIS_W	0x3C2
#define	MIS_R	0x3CC
#define	SEQ_I	0x3C4
#define	PEL_IR	0x3C7
#define	PEL_IW	0x3C8
#define	GRA_I	0x3CE
#define	CRT_IC	0x3D4

static void inline port_out(char value, unsigned short port)
{
__asm__ volatile ("outb %0,%1"
		::"a" ((char) value),"d" ((unsigned short) port));
}

static char inline port_in(unsigned short port)
{
	char _v;
__asm__ volatile ("inb %1,%0"
		:"=a" (_v):"d" ((unsigned short) port));
	return _v;
}


#define flip(value,mask,port)						\
switch (sw) {								\
  case -1: port_out(((value)&~(mask)), (port)); break;			\
  case  0: port_out(((value)^(mask)), (port)); break;			\
  case  1: port_out(((value)|(mask)), (port)); break;			\
  case  2: printf("%s is %s (%x)\n",argv[1],((value)&(mask))?"on":"off",value);	\
}


main(int argc, char *argv[])
{
    int vgaIOBase;
    unsigned char value;
    char sw = 2;

    switch (argc) {
      case 2: sw = 2;
	      break;
      case 3: if (strcmp(argv[2],"on") == 0) sw = 1;
	      else if (strcmp(argv[2],"off") == 0) sw = -1;
	      else if (strcmp(argv[2],"toggle") == 0) sw = 0;
	      else sw = 2;
	      break;
      default:fprintf(stderr,"usage: gdset <function> [on/off/toggle/show]\n");
	      fprintf(stderr,"<function> : rev,bl,cont,tcont,crt,lcd,dith\n");
	      exit(1);
    }

    ioperm(MIS_R,1,1);
    ioperm(MIS_W,1,1);
    vgaIOBase = (port_in(MIS_R) & 0x01) ? 0x3D0 : 0x3B0;
    ioperm(vgaIOBase+4,2,1);
    port_out(0x1D, vgaIOBase + 4);
    value = port_in(vgaIOBase + 5);
    port_out((value | 0x80), vgaIOBase + 5);

    ioperm(CRT_IC,2,1);
    if (strcmp(argv[1],"rev") == 0) {
	port_out(0x1E, CRT_IC);
	value = port_in(CRT_IC+1);
	flip(value, 0x30, CRT_IC+1);
    }
    else if (strcmp(argv[1],"bl") == 0) {
	port_out(0x23, CRT_IC);
	value = port_in(CRT_IC+1);
	flip(value, 0x08, CRT_IC+1);
    }
    else if (strcmp(argv[1],"cont") == 0) {
	port_out(0x08, CRT_IC);
	value = port_in(CRT_IC+1);
	flip(value, 0x80, CRT_IC+1);
    }
    else if (strcmp(argv[1],"tcont") == 0) {
	port_out(0x1E, CRT_IC);
	value = port_in(CRT_IC+1);
	flip(value, 0x02, CRT_IC+1);
    }
    else if (strcmp(argv[1],"crt") == 0) {
	port_out(0x20, CRT_IC);
	value = port_in(CRT_IC+1);
	flip(value, 0x40, CRT_IC+1);
    }
    else if (strcmp(argv[1],"lcd") == 0) {
	port_out(0x20, CRT_IC);
	value = port_in(CRT_IC+1);
	flip(value, 0x20, CRT_IC+1);
    }
    else if (strcmp(argv[1],"dith") == 0) {
	port_out(0x1E, CRT_IC);
	value = port_in(CRT_IC+1);
	flip(value, 0x0D, CRT_IC+1);
    }
    else if (strcmp(argv[1],"nazo") == 0) {
	value = port_in(MIS_R);
	flip(value, 0x0C, MIS_W);
    }

    port_out(0x1D, vgaIOBase + 4);
    value = port_in(vgaIOBase + 5);
    port_out((value & 0x7f), vgaIOBase + 5);

    return(0);
}
